const TYPE_MD = {
    quoted:100,
    100:"quoted"
}

class QuotedTok {
    constructor(s,q,lq,rq) {
        this.type = 100;
        this.lq = lq??q;
        this.rq = rq??lq;
        this.q  = q;
        this.str = s;
    }
    stringify() {return(this.lq+this.str+this.rq)}
    ////
    is_lq()     {return(this.q === this.lq)}
    is_rq()     {return(this.q === this.rq)}
    is_lrq()    {return(this.q === this.lq && this.q === this.rq)}
    ////
    get pair_() {return([this.lq,this.rq])}
    get twin_() {return(this.is_lq()?this.rq:this.lq)}
    ////
    matchr(tok) {return(this.rq === tok.q && this.is_lq() && tok.is_rq())}
    matchl(tok) {return(this.lq === tok.q && this.is_rq() && tok.is_lq())}
    match(tok)  {return(matchr(tok) || match(tok))} 
}


module.exports = {
    TYPE_MD,
    QuotedTok,
    is_qouted_tok:(o)=>(o instanceof QuotedTok),
    is_l2_tok:(o)=> (o.type>=100 && o.type<1000),
}

