class RawTok {
    constructor (si=-1,ei=-1) {
        this.si = si;
        this.ei = ei;
        this.type = 0;
    }
}

class Qtok {
    constructor (si=-1,ei=-1) {
        this.si = si;
        this.ei = ei;
        this.type = 1;
    }
}


class Ptok {
    constructor (si=-1,ei=-1) {
        this.si = si;
        this.ei = ei;
        this.type = 2;
    }
}


const TYPE_MD = {
    raw:0,q:1,p:2,
    0:'raw',1:'q',2:'p'
}


module.exports = {
    RawTok,
    Qtok,
    Ptok,
    TYPE_MD,
    is_raw_tok:(o)=>(o instanceof RawTok),
    is_qtok:(o)=>(o instanceof Qtok),
    is_ptok:(o)=>(o instanceof Ptok),
    is_l0_tok:(o)=> (o.type>=0 && o.type<10)
}
